package com.cpudemo.device;

import com.cpudemo.view.Main;

public class Control {
	public static void doString(String a, String b) {
		Main.jt.append("*******************************************\n");
		Main.jt.append("ֵA" + a + "ԭ:[" + Utils.printString(Utils.toTrueInt(a)) + "]\n");
		Main.jt.append("ֵA" + a + "ķ:[" + Utils.printString(Utils.toMinusInt(Utils.toTrueInt(a))) + "]\n");
		Main.jt.append("ֵA" + a + "Ĳ:[" + Utils.printString(Utils.toComplement(a)) + "]\n\n");
		Main.jt.append("ֵB" + b + "ԭ:[" + Utils.printString(Utils.toTrueInt(b)) + "]\n");
		Main.jt.append("ֵB" + b + "ķ:[" + Utils.printString(Utils.toMinusInt(Utils.toTrueInt(b))) + "]\n");
		Main.jt.append("ֵB" + b + "Ĳ:[" + Utils.printString(Utils.toComplement(b)) + "]\n");
		Main.jt.append("*******************************************\n\n");

	}

	// ӷ
	public static void doAdd(String a, String b) {
		Main.jt.append("*******************************************\n");
		int[] i = Arithmetic.bitAdder(Utils.toComplement(a), Utils.toComplement(b));
		Main.jt.append("" + a + "+" + b + "Ľƣ:[" + Utils.printString(i) + "]\n");
		Main.jt.append("" + a + "+" + b + "Ľʮƣ:[" + Utils.toTen(i) + "]\n");
		Main.jt.append("ȫָ־λN" + Arithmetic.N + "\nȫ־λV" + Arithmetic.V + "\nȫֽλλ־C" + Arithmetic.C
				+ "\nȫ־λZ" + Arithmetic.Z + "\n");
		Main.jt.append("*******************************************\n\n");

	}

	// 
	public static void doMinus(String a, String b) {
		Main.jt.append("*******************************************\n");
		String c = Integer.parseInt(b) * -1 + "";
		int[] i = Arithmetic.bitAdder(Utils.toComplement(a), Utils.toComplement(c));
		Main.jt.append("" + a + "-" + b + "Ľƣ:[" + Utils.printString(i) + "]\n");
		Main.jt.append("" + a + "-" + b + "Ľʮƣ:[" + Utils.toTen(i) + "]\n");
		Main.jt.append("ȫָ־λN" + Arithmetic.N + "\nȫ־λV" + Arithmetic.V + "\nȫֽλλ־C" + Arithmetic.C
				+ "\nȫ־λZ" + Arithmetic.Z + "\n");
		Main.jt.append("*******************************************\n\n");
	}

	// ˷
	public static void doMultiply(String a, String b, boolean isComputer) {
		Main.jt.append("*******************************************\n");

		int[] inta = Utils.toComplement(a);
		int[] intb = Utils.toComplement(b);
		int[] sum = Utils.toComplement("0");

		if (!isComputer) {
			// ˹㷽ʽ
			Main.jt.append("--˹㷽ʽ--\n");
			for (int i = Arithmetic.bit - 1; i >= 0; i--) {
				if (intb[i] == 1) {
					sum = Arithmetic.bitAdder(sum, inta);
				}
				inta = Arithmetic.bitShifter(inta, true, 0);
			}

		} else {
			// CPUʽģ
			Main.jt.append("--cpuʽģ--\n\n");
			for (int i = Arithmetic.bit - 1; i >= 0; i--) {
				if (intb[Arithmetic.bit - 1] == 1) {
					sum = Arithmetic.bitAdder(sum, inta);
				}
				intb = Arithmetic.bitShifter(intb, false, sum[Arithmetic.bit - 1]);
				sum = Arithmetic.bitShifter(sum, false, 0);
			}
			for (int i = 0; i < Arithmetic.bit; i++) {
				sum = Arithmetic.bitShifter(sum, true, intb[i]);
			}
		}
		Arithmetic.N = sum[0];
		Main.jt.append("" + a + "*" + b + "Ľƣ:[" + Utils.printString(sum) + "]\n");
		Main.jt.append("" + a + "*" + b + "Ľʮƣ:[" + Utils.toTen(sum) + "]\n");
		Main.jt.append("ȫָ־λN" + Arithmetic.N + "\nȫ־λV" + Arithmetic.V + "\nȫֽλλ־C" + Arithmetic.C
				+ "\nȫ־λZ" + Arithmetic.Z + "\n");
		Main.jt.append("*******************************************\n\n");
	}
}
