package com.cpudemo.device;

import com.cpudemo.view.Main;

//
public class Utils {

	// ӡ
	public static void printLOG(int[] b, String tell) {
		String t = "";
		for (int i = 0; i < b.length; i++) {
			t = t + b[i];
		}
		Main.jt.append(tell + ":" + t + "\n");
	}

	// ̨ӡ
	public static void printConsole(int[] b) {
		for (int i = 0; i < b.length; i++) {
			System.out.print(b[i]);
		}
		System.out.println();
	}

	// תַ
	public static String printString(int[] b) {
		String str = "";
		for (int i = 0; i < b.length; i++) {
			str = str + b[i];
		}
		return str;
	}

	// Ʋתʮ
	public static int toTen(int[] a) {
		int result = 0;
		if (a[0] == 1) {
			for (int i = 0; i < a.length; i++) {
				a[i] = 1 ^ a[i];
				result = result + (int) (a[i] * Math.pow(2, a.length - i - 1));
			}
			result = (result + 1) * -1;
		} else {
			for (int i = 0; i < a.length; i++) {
				result = result + (int) (a[i] * Math.pow(2, a.length - i - 1));
			}
		}
		if (result == 0) {
			Arithmetic.Z = 1;
		} else {
			Arithmetic.Z = 0;
		}
		return result;
	}

	// String ת int
	public static int toInt(String str) {
		int n;
		try {
			n = Integer.parseInt(str);
		} catch (NumberFormatException e) {
			Main.jt.append("" + str + "ֵֻ( )\n");
			Main.jt.append("ֹ\n");
			Main.tell("" + str + "ֻ򳬷Χ( )", true);
			throw new RuntimeException("" + str + "ֵֻ( )");
		}
		if (Arithmetic.negative) {
			return n;
		} else {
			return Math.abs(n);
		}
	}

	// String ת Ʋ(int)
	public static int[] toComplement(String str) {
		int n = toInt(str);
		String result = "";
		boolean minus = false;

		// Ϊôиø+1֮ľֵĶĶӦλȡȻresult
		if (n < 0) {
			minus = true;
			n = Math.abs(n + 1);
		}

		while (true) {
			int remainder = (!minus && n % 2 == 0) || (minus && n % 2 == 1) ? 0 : 1;
			// ڽ
			result = remainder + result;
			n /= 2;
			if (n == 0) {
				break;
			}

		}
		// жǷΪǸôǰλ1
		if (minus) {
			n = result.length();
			for (int i = 1; i <= Arithmetic.bit - n; i++) {
				result = 1 + result;
			}
		} else {
			n = result.length();
			for (int i = 1; i <= Arithmetic.bit - n; i++) {
				result = 0 + result;
			}
		}
		int[] binary = new int[Arithmetic.bit];
		if (result.length() == Arithmetic.bit) {
			for (int i = 0; i < result.length(); i++) {
				String s = result.charAt(i) + "";
				binary[i] = Integer.parseInt(s);
			}
			Utils.valiLength(binary, Arithmetic.bit);
		} else {
			// ʾ
			Main.jt.append("ʾ:ֵΧ\n");
			Main.jt.append("ֹ\n");
			Main.tell(":ֵΧ", true);
			throw new RuntimeException("ʾ");
		}

		return binary;
	}

	// ԭ
	public static int[] toTrueInt(String str) {
		/**
		 * @Сȡ:Math.floor(3.5)=3
		 * @ȡ:Math.rint(3.5)=4
		 * @λȡ:Math.ceil(3.1)=4 @ȡֵMath.abs(-3.5)=3.5 @ȡA%B = 
		 * @Stringתint Integer.parseInt(str) Integer.valueOf(str).intValue();
		 * @ʮתAPI Integer.toBinaryString(10)
		 */
		int remainder;// һڴ洢
		int sum = 0;// һڴź
		int k = 1;// һλ
		int a = toInt(str);
		String result = "";
		boolean minus = false;// һλ

		if (a < 0) {
			a = Math.abs(a);
			minus = true;
		}
		while (a != 0) {
			remainder = a % 2;// Ŀ
			a /= 2;// Ŀ
			result = remainder + result;
			sum = sum + remainder * k;// 
			k *= 10;// ıλ
		}

		for (int i = Arithmetic.bit - result.length(); i > 0; i--) {
			result = "0" + result;
		}
		int[] binary = new int[Arithmetic.bit];
		if (result.length() == Arithmetic.bit) {
			for (int i = 0; i < result.length(); i++) {
				String s = result.charAt(i) + "";
				binary[i] = Integer.parseInt(s);
			}
			Utils.valiLength(binary, Arithmetic.bit);
		} else {
			// ʾ
			Main.jt.append("ʾ:ֵΧ\n");
			Main.jt.append("ֹ\n");
			Main.tell(":ֵΧ", true);
			throw new RuntimeException("ʾ");
		}
		if (minus) {
			binary[0] = 1;
			sum = sum + 1 * k;
			result = "1" + result;
		} else {
			binary[0] = 0;
			sum = sum + 0 * k;
			result = "0" + result;
		}
		Utils.valiLength(binary, Arithmetic.bit);
		return binary;
	}

	// 
	public static int[] toMinusInt(int[] a) {
		if (a[0] == 1) {
			for (int i = 0; i < a.length; i++) {
				a[i] = a[i] ^ 1;
			}
			a[0] = 1;
		}
		return a;
	}

	// (rbl)
	public static int[] toComplementInt(int[] a) {
		if (a[0] == 1) {
			a = toMinusInt(a);
			a = Arithmetic.bitAdder(a, toTrueInt("1"));
			a[0] = 1;
		}
		return a;
	}

	/**
	 * ʾ
	 */
	// ֻ01
	public static void valiDate(int a, int b) {
		if ((a != 0 && a != 1) || (b != 0 && b != 1)) {
			Main.jt.append("Ƿ");
			// throw new RuntimeException("Ƿ");
		}
	}

	// ֻ01
	public static void valiDate(int b) {
		if (b != 0 && b != 1) {
			Main.jt.append("Ƿ");
			// throw new RuntimeException("Ƿ");
		}
	}

	// ֤
	public static void valiLength(int[] a, int bit) {
		if (a == null || a.length != bit) {
			Main.jt.append("Ƿλ[" + a.length + "]ǰ֤λ[" + bit + "],ҷλ[" + Arithmetic.negative + "]\n");
			// Main.tell("Ƿλ[" + a.length + "]ǰ֤λ[" + bit + "],ҷλ[" +
			// Arithmetic.negative + "]", true);
			// throw new RuntimeException("Ƿλ[" + a.length + "]ǰ֤λ[" + bit +
			// "],ҷλ[" + Arithmetic.negative + "]");
		}
	}

}
