package com.cpudemo.view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.cpudemo.device.Arithmetic;
import com.cpudemo.device.Control;

public class Main {

	public static JFrame frmAlu;
	public static JTextField nbA;
	public static JTextField nbB;
	public static JTextArea jt;
	private static JButton btnRun;
	private static JButton btnCls;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmAlu = new JFrame();
		frmAlu.setTitle(Arithmetic.bit + "λ---ȴ...");
		Toolkit kit = Toolkit.getDefaultToolkit();
		Dimension screen = kit.getScreenSize();
		int x = screen.width;
		int y = screen.height;
		// setSize(x,y); /*ϵͳƽʾ*/
		int xcenter = (x - 700) / 2;
		int ycenter = (y - 480) / 2;
		frmAlu.setBounds(xcenter, ycenter, 700, 450);
		frmAlu.setResizable(false);
		frmAlu.setVisible(true);
		frmAlu.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		JPanel top = new JPanel();
		frmAlu.getContentPane().add(top, BorderLayout.NORTH);
		JLabel lbla = new JLabel("ֵA:");
		top.add(lbla);
		nbA = new JTextField();
		top.add(nbA);
		nbA.setColumns(15);
		JLabel lblb = new JLabel("ֵB:");
		top.add(lblb);
		nbB = new JTextField();
		top.add(nbB);
		nbB.setColumns(15);
		btnRun = new JButton("");
		top.add(btnRun);
		btnCls = new JButton("λ");
		btnCls.setEnabled(false);
		top.add(btnCls);

		JPanel panel = new JPanel();
		panel.setBackground(Color.LIGHT_GRAY);
		panel.setBorder(BorderFactory.createTitledBorder("̨"));
		frmAlu.getContentPane().add(panel, BorderLayout.CENTER);
		jt = new JTextArea(3, 20);
		jt.paintImmediately(jt.getBounds());
		jt.setFont(new Font("Dialog", 1, 18));
		jt.setEnabled(true);
		jt.setLineWrap(true);// ݹԶ
		jt.setText("Log:\n");
		JScrollPane scr = new JScrollPane(jt, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		panel.setLayout(new GridLayout(1, 1));
		panel.add(scr);
		panel.setSize(300, 150);
		panel.setLocation(300, 200);

		nbA.addKeyListener(new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {
			}// ַ

			@Override
			public void keyReleased(KeyEvent e) {
			}// 

			@Override
			public void keyPressed(KeyEvent e) {
				// ´
				if (e.getKeyChar() == KeyEvent.VK_ENTER) {
					doRun();
				}
			}
		});

		nbB.addKeyListener(new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {
			}// ַ

			@Override
			public void keyReleased(KeyEvent e) {
			}// 

			@Override
			public void keyPressed(KeyEvent e) {
				// 
				if (e.getKeyChar() == KeyEvent.VK_ENTER) {
					doRun();
				}
			}
		});

		btnCls.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Զɵķ
				btnRun.setEnabled(true);
				nbA.setText("");
				nbB.setText("");
				jt.setText("Log:\n");
				btnCls.setEnabled(false);
				nbA.setEditable(true);
				nbB.setEditable(true);
				frmAlu.setTitle(Arithmetic.bit + "λ---ȴ...");
			}
		});

		btnRun.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Զɵķ
				doRun();
			}
		});
	}

	private void doRun() {
		String a = nbA.getText();
		String b = nbB.getText();
		jt.append("==================================\n");
		btnCls.setEnabled(true);
		btnRun.setEnabled(false);
		nbA.setEditable(false);
		nbB.setEditable(false);
		if (a.equals("")) {
			frmAlu.setTitle(":ֵAΪգ");
			jt.append(":ֵAΪգ\n");
		} else if (b.equals("")) {
			frmAlu.setTitle(":ֵBΪգ");
			jt.append(":ֵBΪգ\n");
		} else {
			jt.append("------------------------------------------------------------------------------\n");
			jt.append("ǰЧλΪ[" + Arithmetic.bit + "]λҷλ״̬" + Arithmetic.negative + "\n");
			jt.append("------------------------------------------------------------------------------\n\n");
			jt.append("ת\n");
			Control.doString(a, b);
			jt.append("Ƽӷ\n");
			Control.doAdd(a, b);
			jt.append("Ƽ\n");
			Control.doMinus(a, b);
			jt.append("Ƴ˷\n");
			Control.doMultiply(a, b, true);
			frmAlu.setTitle("ʾ:ȫ");
		}

		jt.append("==================================\nEND \n");
	}

	public static int tell(String str, boolean ans) {
		int flag = 1;
		if (ans) {
			JOptionPane.showMessageDialog(frmAlu, str);
		} else {
			flag = JOptionPane.showConfirmDialog(frmAlu, str, "ѯ", JOptionPane.YES_NO_OPTION);
		}
		return flag;
	}
}
